#include <netinet/in.h> // sockaddr_in
#include <sys/types.h> //socket
#include <sys/socket.h> //socket
#include <netdb.h> //gethostbyname
#include <unistd.h> //close
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <arpa/inet.h> //inet_addr

#define SERVVER_PORT 12138
#define LISTEN_QUEUE 20
#define BUFFER_SIZE 1024

struct Addr
{
    char host[64];
    int port;
};

int file_push(struct Addr addr,char *filenames)
{
    struct sockaddr_in servAddr;
    struct hostent * host;
    int sockfd;
    FILE *fp;

    host=gethostbyname(addr.host);
    servAddr.sin_family=AF_INET;
    servAddr.sin_addr=*((struct in_addr *)host->h_addr);
    //servAddr.sin_addr.s_addr=inet_addr("127.0.0.1");
    servAddr.sin_port=htons(addr.port);
    if(host==NULL)
    {
        perror("获取IP地址失败");
        exit(-1);
    }
    if((sockfd=socket(AF_INET,SOCK_STREAM,0))==-1)
    {
        perror("socket创建失败");
        exit(-1);
    }

    if(connect(sockfd,(struct sockaddr *)&servAddr,sizeof(struct sockaddr_in))== -1)
    {
        perror("connect 失败");
        exit(-1);
    }

    //打开文件
    if((fp=fopen(filenames,"rb"))==NULL)
    {
        perror("文件打开失败");
        exit(-1);
    }
    char buffer[BUFFER_SIZE];
    bzero(buffer,BUFFER_SIZE);
    printf("正在传输文件");
    int len=0;
    //不断的读取文件直到文件结束
    while((len=fread(buffer,1,BUFFER_SIZE,fp))>0)
    {
        if(send(sockfd,buffer,len,0)<0)
        {
            perror("发送数据失败");
            exit(-1);
        }
        bzero(buffer,BUFFER_SIZE);
        printf(".");//1K打印一个点//如果要实现百分比，就要计算文件大小，然后再处理即可
    }

    fclose(fp);//关闭文件流
    close(sockfd);//关闭socket连接

    return 0;
}

int main(int argc,char *argv[])
{
    char orderbuf[BUFFER_SIZE];
    char orderch[BUFFER_SIZE];
    struct Addr addr;

    strcpy(addr.host,argv[1]);
    addr.port=atoi(argv[2]);
    while(1)
    {
        printf("\n请输入文件名:");
        fgets(orderbuf,BUFFER_SIZE,stdin);
        orderbuf[strlen(orderbuf)-1]=0;//去掉获取到的回车符
        //printf("%s\n",orderbuf);
        file_push(addr,orderbuf);
    }

    return 0;
}
